]> git.treefish.org Git - backmeupscotty.git/blobdiff - backmeupscotty
Cleaned up info and error messages.
[backmeupscotty.git] / backmeupscotty
index 9087a17c2a2064fb8a7a031ee783caaed7ed3c52..be1ce209a4de43dba7ad413ce52cc98a3d9f0fc9 100644 (file)
@@ -18,12 +18,24 @@ function scottyerror {
     echo $(upperme): $@ >&2 
 }
 
     echo $(upperme): $@ >&2 
 }
 
+function ssh255 {
+    ssh $@
+    sshret=$?
+
+    if [ $sshret -eq 255 ]; then
+       scottyerror "SSH connection failed!"
+       exit 1
+    else
+       return $sshret
+    fi
+}
+
 function grepbackups {
 function grepbackups {
-    ssh $REMOTE_HOST "ls $REMOTE_DIR" | grep -E '[0-9]+-[0-9]+'
+    ssh255 $REMOTE_HOST "ls $REMOTE_DIR" | grep -E '[0-9]+-[0-9]+'
 }
 
 function isIncomplete {
 }
 
 function isIncomplete {
-    if ( ssh $REMOTE_HOST '[ -d '$REMOTE_DIR/incomplete' ]' ); then
+    if ( ssh255 $REMOTE_HOST '[ -d '$REMOTE_DIR/incomplete' ]' ); then
        return 0
     else
        return 1
        return 0
     else
        return 1
@@ -44,7 +56,7 @@ function latestTooOld {
        tstamp=$(echo $oldbackup | cut -d'-' -f1)
        
        if [ $(( $(date +%s) - $tstamp )) -lt \
        tstamp=$(echo $oldbackup | cut -d'-' -f1)
        
        if [ $(( $(date +%s) - $tstamp )) -lt \
-           $(( $BACKUP_RUNEVERYNTHDAY*24*60*60 )) ]
+           $(( ($BACKUP_RUNEVERYNTHDAY*24+12)*60*60 )) ]
        then
            return 1
        fi
        then
            return 1
        fi
@@ -56,15 +68,15 @@ function latestTooOld {
 function scottysync {
     timestamp=$(date +%s)
 
 function scottysync {
     timestamp=$(date +%s)
 
-    scottyinfo Syncing $SYNC_SRC to $REMOTE_HOST:$REMOTE_DIR @$timestamp
+    scottyinfo "Syncing $SYNC_SRC to $REMOTE_HOST:$REMOTE_DIR @$timestamp."
 
     if [ ! -d "$SYNC_SRC" ]; then
 
     if [ ! -d "$SYNC_SRC" ]; then
-       scottyerror Source dir $SYNC_SRC does not exist. Not syncing!
+       scottyerror "Source dir $SYNC_SRC does not exist. Not syncing!"
        return 1
     fi
 
     if [ $(ls -A "$SYNC_SRC" | wc -l) -eq 0 ]; then
        return 1
     fi
 
     if [ $(ls -A "$SYNC_SRC" | wc -l) -eq 0 ]; then
-       scottyerror Source dir $SYNC_SRC is empty. Not syncing!
+       scottyerror "Source dir $SYNC_SRC is empty. Not syncing!"
        return 1
     fi
 
        return 1
     fi
 
@@ -78,16 +90,16 @@ function scottysync {
        rsync_exclude=$(eval echo --exclude={$SYNC_EXC} | tr -d {})
     fi
 
        rsync_exclude=$(eval echo --exclude={$SYNC_EXC} | tr -d {})
     fi
 
-    if (ssh $REMOTE_HOST '[ ! -d '$REMOTE_DIR' ]'); then
-       scottyinfo Creating destination directory $REMOTE_HOST:$REMOTE_DIR
-       ssh $REMOTE_HOST "mkdir $REMOTE_DIR"
+    if (ssh255 $REMOTE_HOST '[ ! -d '$REMOTE_DIR' ]'); then
+       scottyinfo "Creating destination directory $REMOTE_HOST:$REMOTE_DIR."
+       ssh255 $REMOTE_HOST "mkdir $REMOTE_DIR"
     fi
 
     if isIncomplete; then
     fi
 
     if isIncomplete; then
-       scottyerror Continuing old incomplete backup
+       scottyerror "Continuing old incomplete backup."
     fi
 
     fi
 
-    scottyinfo Starting rsync
+    scottyinfo "Starting rsync."
     rsync -e ssh \
        -v -aHAX --numeric-ids --delete --delete-excluded \
        --link-dest=$dir_current \
     rsync -e ssh \
        -v -aHAX --numeric-ids --delete --delete-excluded \
        --link-dest=$dir_current \
@@ -95,8 +107,8 @@ function scottysync {
        $SYNC_SRC/ $REMOTE_HOST:$dir_incomplete/
     
     if [ $? -eq 0 ]; then
        $SYNC_SRC/ $REMOTE_HOST:$dir_incomplete/
     
     if [ $? -eq 0 ]; then
-       scottyinfo Timestamping completed backup and linking to current backup
-       ssh $REMOTE_HOST \
+       scottyinfo "Timestamping completed backup and linking to current backup."
+       ssh255 $REMOTE_HOST \
            "mv $dir_incomplete $dir_timestamped && rm -f $dir_current && ln -s $(basename $dir_timestamped) $dir_current"
     fi
 
            "mv $dir_incomplete $dir_timestamped && rm -f $dir_current && ln -s $(basename $dir_timestamped) $dir_current"
     fi
 
@@ -105,8 +117,8 @@ function scottysync {
        oldestbackuptstamp=$(echo $oldestbackup | cut -d'-' -f1)
 
        if [ $oldestbackuptstamp -lt $(( $(date +%s) - $ARCHIVE_KEEPNDAYS*60*60*24 )) ]; then
        oldestbackuptstamp=$(echo $oldestbackup | cut -d'-' -f1)
 
        if [ $oldestbackuptstamp -lt $(( $(date +%s) - $ARCHIVE_KEEPNDAYS*60*60*24 )) ]; then
-           scottyinfo Removing old backup $oldestbackup
-           ssh $REMOTE_HOST rm -r "$REMOTE_DIR/$oldestbackup"
+           scottyinfo "Removing old backup $oldestbackup."
+           ssh255 $REMOTE_HOST rm -r "$REMOTE_DIR/$oldestbackup"
        else
            break
        fi
        else
            break
        fi
@@ -120,16 +132,16 @@ function deleteLock {
 }
 
 function prepare {
 }
 
 function prepare {
-    scottyinfo "Preparing for sync"
+    scottyinfo "Preparing for sync."
 }
 
 function cleanup_abort {
 }
 
 function cleanup_abort {
-    scottyerror "Caught exit signal! Cleaning up..."
+    scottyerror "Caught exit signal! Cleaning up."
 
     cleanup ABORT
 
     if [ $(jobs -p) ]; then
 
     cleanup ABORT
 
     if [ $(jobs -p) ]; then
-       scottyerror TERMinating remaining child processes...
+       scottyerror "TERMinating remaining child processes."
        kill $(jobs -p)
     fi
 
        kill $(jobs -p)
     fi
 
@@ -177,16 +189,13 @@ function backmeupscotty {
                 ;;
        esac
     done
                 ;;
        esac
     done
+    
+    ssh255 $REMOTE_HOST exit
 
 
-    if (! ssh -q $REMOTE_HOST exit); then
-       scottyerror "Could not establish SSH connection to $REMOTE_HOST!"
-       exit 1
-    fi
-
-    if isNthDay; then
+    if latestTooOld; then
+       scottyerror "The latest backup is too old."
+    elif isNthDay; then
        scottyinfo "This is the nth day."
        scottyinfo "This is the nth day."
-    elif latestTooOld; then
-       scottyinfo "The latest backup is too old."
     else
        scottyinfo "No backup has to be done. Exiting."
        exit 0
     else
        scottyinfo "No backup has to be done. Exiting."
        exit 0